// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _LIBGDAMM_TRANSACTIONSTATUS_H
#define _LIBGDAMM_TRANSACTIONSTATUS_H


#include <glibmm.h>

/* $Id: transactionstatus.hg,v 1.2 2006/12/23 09:34:17 murrayc Exp $ */
// -*- C++ -*- //

/* transactionstatus.h
 * 
 * Copyright 2001      Free Software Foundation
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <glibmm/object.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GdaTransactionStatus GdaTransactionStatus;
typedef struct _GdaTransactionStatusClass GdaTransactionStatusClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Gda
{ class TransactionStatus_Class; } // namespace Gda

} // namespace Gnome
namespace Gnome
{
  
namespace Gda
{

/** @addtogroup libgdammEnums libgdamm Enums and Flags */

/**
 * @ingroup libgdammEnums
 */
enum TransactionIsolation
{
  TRANSACTION_ISOLATION_UNKNOWN,
  TRANSACTION_ISOLATION_READ_COMMITTED,
  TRANSACTION_ISOLATION_READ_UNCOMMITTED,
  TRANSACTION_ISOLATION_REPEATABLE_READ,
  TRANSACTION_ISOLATION_SERIALIZABLE
};

} // namespace Gda

} // namespace Gnome


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gnome::Gda::TransactionIsolation> : public Glib::Value_Enum<Gnome::Gda::TransactionIsolation>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gnome
{

namespace Gda
{


/** Keeps track of the transactional status of a connection.
 *
 * On any connection (as a Connection object), if the database provider used by the connection supports it, 
 * transactions may be started, committed or rolledback, or savepoints added, removed or rolledback. 
 * These operations can be performed using libgda's API (such as Connection::begin_transaction()), or directly using some 
 * SQL on the connection (usually a "BEGIN;" command). The TransactionStatus's aim is to make it easy to keep track of 
 * all the commands which have been issued on a connection regarding transactions.
 * 
 * One TransactionStatus object is automatically attached to a Connection when a transaction is started, and is destroyed 
 * when the transaction is finished. This object can be fetched using Connection::get_transaction_status() (beware that it should then not be modified).
 *
 * @ingroup Connections
 */

class TransactionStatus : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef TransactionStatus CppObjectType;
  typedef TransactionStatus_Class CppClassType;
  typedef GdaTransactionStatus BaseObjectType;
  typedef GdaTransactionStatusClass BaseClassType;

private:  friend class TransactionStatus_Class;
  static CppClassType transactionstatus_class_;

private:
  // noncopyable
  TransactionStatus(const TransactionStatus&);
  TransactionStatus& operator=(const TransactionStatus&);

protected:
  explicit TransactionStatus(const Glib::ConstructParams& construct_params);
  explicit TransactionStatus(GdaTransactionStatus* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~TransactionStatus();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;


  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GdaTransactionStatus*       gobj()       { return reinterpret_cast<GdaTransactionStatus*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GdaTransactionStatus* gobj() const { return reinterpret_cast<GdaTransactionStatus*>(gobject_); }

  ///Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.
  GdaTransactionStatus* gobj_copy();

private:

protected:
  explicit TransactionStatus(const Glib::ustring& name = Glib::ustring());
  

public:
  
  static Glib::RefPtr<TransactionStatus> create(const Glib::ustring& name);


   TransactionIsolation get_get_isolation_level() const;
    Glib::ustring get_get_name() const;
 

public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


};

} // namespace Gda
} // namespace Gnome


namespace Glib
{
  /** A Glib::wrap() method for this object.
   * 
   * @param object The C instance.
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   *
   * @relates Gnome::Gda::TransactionStatus
   */
  Glib::RefPtr<Gnome::Gda::TransactionStatus> wrap(GdaTransactionStatus* object, bool take_copy = false);
}


#endif /* _LIBGDAMM_TRANSACTIONSTATUS_H */

